/************************************************************
3217 Phoenixville Pike
Malvern, PA  19355
800 321-5355 or 610 725-8800
http://www.lawsonlabs.com
VC++ demo. program for M40x A/D board,
Uses DLL: M40x.DLL to access M401
*************************************************************/


// ExScanVoltDlg.cpp : implementation file
//

#include "stdafx.h"
#include "m40xvc.h"
#include "ExScanVoltDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define RECT_WIDTH(r) (r.right - r.left +1)
#define RECT_HEIGHT(r) (r.bottom - r.top + 1)

//////////////////////////////////////
///////////////////////////////////////
// CExScanVoltDlg dialog
extern INDEX_CONTEXT  Context[MAX_M401];
extern UINT uSelected_Index;
extern CString FormatVolt(double fVolt, UINT uIndex);
extern CM40xVCApp theApp;

CExScanVoltDlg::CExScanVoltDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExScanVoltDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExScanVoltDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_flgFirstTime = TRUE;
}


void CExScanVoltDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExScanVoltDlg)
	DDX_Control(pDX, IDC_TXT_SCAN_RATE, m_TxtScanRate);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CExScanVoltDlg, CDialog)
	//{{AFX_MSG_MAP(CExScanVoltDlg)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExScanVoltDlg message handlers

BOOL CExScanVoltDlg::OnInitDialog() 
{

	CDialog::OnInitDialog();	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}




BOOL CExScanVoltDlg::Create(UINT nIDTemplate, CWnd *pParentWnd)
{
	if(CDialog::Create(nIDTemplate, pParentWnd)){
		m_LblAD0.SubclassDlgItem(IDC_LBL_VAD0,this);
		m_LblAD1.SubclassDlgItem(IDC_LBL_VAD1,this);
		m_LblAD6.SubclassDlgItem(IDC_LBL_VAD6,this);
		m_LblAD7.SubclassDlgItem(IDC_LBL_VAD7,this);
		SaveOrgRects();
		//AD0 subchans into objects
		m_SAD0[0].SubclassDlgItem(IDC_SAD0,this);
		m_SAD0[1].SubclassDlgItem(IDC_SAD1,this);
		m_SAD0[2].SubclassDlgItem(IDC_SAD2,this);
		m_SAD0[3].SubclassDlgItem(IDC_SAD3,this);
		m_SAD0[4].SubclassDlgItem(IDC_SAD4,this);
		m_SAD0[5].SubclassDlgItem(IDC_SAD5,this);
		m_SAD0[6].SubclassDlgItem(IDC_SAD6,this);
		m_SAD0[7].SubclassDlgItem(IDC_SAD7,this);
		m_SAD0[8].SubclassDlgItem(IDC_SAD8,this);
		m_SAD0[9].SubclassDlgItem(IDC_SAD9,this);
		m_SAD0[10].SubclassDlgItem(IDC_SAD10,this);
		m_SAD0[11].SubclassDlgItem(IDC_SAD11,this);
		m_SAD0[12].SubclassDlgItem(IDC_SAD12,this);
		m_SAD0[13].SubclassDlgItem(IDC_SAD13,this);
		m_SAD0[14].SubclassDlgItem(IDC_SAD14,this);
		m_SAD0[15].SubclassDlgItem(IDC_SAD15,this);
		//AD1 subchans into objects
		m_SAD1[0].SubclassDlgItem(IDC_SAD16,this);
		m_SAD1[1].SubclassDlgItem(IDC_SAD17,this);
		m_SAD1[2].SubclassDlgItem(IDC_SAD18,this);
		m_SAD1[3].SubclassDlgItem(IDC_SAD19,this);
		m_SAD1[4].SubclassDlgItem(IDC_SAD20,this);
		m_SAD1[5].SubclassDlgItem(IDC_SAD21,this);
		m_SAD1[6].SubclassDlgItem(IDC_SAD22,this);
		m_SAD1[7].SubclassDlgItem(IDC_SAD23,this);
		m_SAD1[8].SubclassDlgItem(IDC_SAD24,this);
		m_SAD1[9].SubclassDlgItem(IDC_SAD25,this);
		m_SAD1[10].SubclassDlgItem(IDC_SAD26,this);
		m_SAD1[11].SubclassDlgItem(IDC_SAD27,this);
		m_SAD1[12].SubclassDlgItem(IDC_SAD28,this);
		m_SAD1[13].SubclassDlgItem(IDC_SAD29,this);
		m_SAD1[14].SubclassDlgItem(IDC_SAD30,this);
		m_SAD1[15].SubclassDlgItem(IDC_SAD31,this);
		//AD6 
		m_SAD6.SubclassDlgItem(IDC_SAD32,this);
		//AD7
		m_SAD7.SubclassDlgItem(IDC_SAD33,this);	
		return TRUE;
	}
	return FALSE;
}

void CExScanVoltDlg::MoveToX(LONG X, CWnd *pWnd)
{
	RECT rTemp;
	LONG lTemp;
	pWnd->GetWindowRect(&rTemp);
	this->ScreenToClient(&rTemp);
	//.......rTemp.right = RECT_WIDTH(rTemp);
	//.......rTemp.bottom = RECT_HEIGHT(rTemp);
	lTemp = RECT_WIDTH(rTemp);
	rTemp.left = X;
	rTemp.right = X + lTemp-1;
	pWnd->MoveWindow(&rTemp);
	pWnd->ShowWindow(SW_SHOW);

}

void CExScanVoltDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	BYTE i;
	CString s;
	CDialog::OnShowWindow(bShow, nStatus);	
	// TODO: Add your message handler code here
	if(bShow){		
		/*
			Move all controls to original places and make all visible
		*/	
		if(Context[uSelected_Index].bExtCalScan){
			SetWindowText("EXTENDED CALIBRATION SCAN");
		}
		else{
			SetWindowText("EXTENDED SCAN");
		}
		
		RestoreOrgRects();
		this->MoveWindow(&rMain);		
		m_LblAD0.MoveWindow(&rAD0);
		m_LblAD0.ShowWindow(SW_SHOW);		
		m_LblAD1.MoveWindow(&rAD1);
		m_LblAD1.ShowWindow(SW_SHOW);
		m_LblAD6.MoveWindow(&rAD6);
		m_LblAD6.ShowWindow(SW_SHOW);
		m_LblAD7.MoveWindow(&rAD7);
		m_LblAD7.ShowWindow(SW_SHOW);
		for(i=0;i<16;i++){
			MoveToX(rAD0.left,&m_SAD0[i]);
			m_SAD0[i].ShowWindow(SW_SHOW);
			m_SAD0[i].SetWindowText("");
			MoveToX(rAD1.left,&m_SAD1[i]);
			m_SAD1[i].ShowWindow(SW_SHOW);
			m_SAD1[i].SetWindowText("");
		}

		MoveToX(rAD6.left,&m_SAD6);
		m_SAD6.ShowWindow(SW_SHOW);
		m_SAD6.SetWindowText("");
		MoveToX(rAD7.left,&m_SAD7);
		m_SAD7.ShowWindow(SW_SHOW);	
		m_SAD7.SetWindowText("");
		//Shrink dialog to only active channels (columns)		
		if(Context[uSelected_Index].ExtScan_AD0_Start < 0){
			// Skipping AD0 colmn move left by a column
			m_LblAD0.ShowWindow(SW_HIDE);		
			MoveToX(rAD0.left,&m_LblAD1);
			MoveToX(rAD1.left,&m_LblAD6);
			MoveToX(rAD6.left,&m_LblAD7);
			for(i=0;i<16;i++){
				MoveToX(rAD0.left,&m_SAD1[i]);		
				m_SAD0[i].ShowWindow(SW_HIDE);
			}
			MoveToX(rAD1.left,&m_SAD6);			
			MoveToX(rAD6.left,&m_SAD7);			
		}
		else{
			rMain.right = rMain.left + rAD0.right + 20;
			MoveWindow(&rMain);
		}
		UpdateColRects();
		if(Context[uSelected_Index].ExtScan_AD1_Start < 0){
			// Skipping AD1 colmn move left by a column
			m_LblAD1.ShowWindow(SW_HIDE);					
			MoveToX(rAD1.left,&m_LblAD6);
			MoveToX(rAD6.left,&m_LblAD7);
			for(i=0;i<16;i++){
				m_SAD1[i].ShowWindow(SW_HIDE);				
			}
			MoveToX(rAD1.left,&m_SAD6);			
			MoveToX(rAD6.left,&m_SAD7);			
		}
		else{
			rMain.right = rMain.left + rAD1.right + 20;
			MoveWindow(&rMain);
		}
		UpdateColRects();
		if(!Context[uSelected_Index].ExtScan_AD6){
			// Skipping AD6 colmn move left by a column
			m_LblAD6.ShowWindow(SW_HIDE);
			MoveToX(rAD6.left,&m_LblAD7);
			m_SAD6.ShowWindow(SW_HIDE);				
			MoveToX(rAD6.left,&m_SAD7);
		}
		else{
			rMain.right = rMain.left + rAD6.right + 20;
			MoveWindow(&rMain);
		}
		UpdateColRects();
		if(!Context[uSelected_Index].ExtScan_AD7){
			// Skipping AD7 colmn move left by a column
			m_LblAD7.ShowWindow(SW_HIDE);
			m_SAD7.ShowWindow(SW_HIDE);

		}
		else{
			rMain.right = rMain.left + rAD7.right + 20;
			MoveWindow(&rMain);
		}
		s.Format("%.2f",theApp.DLL_Scan_obj[uSelected_Index].fMultiChanScanRate);
		m_TxtScanRate.SetWindowText(s);		
	}
	// TODO: Add extra initialization here	
}

void CExScanVoltDlg::SaveOrgRects()
{
		m_LblAD0.GetWindowRect(&rOrgAD0);		
		m_LblAD1.GetWindowRect(&rOrgAD1);
		m_LblAD6.GetWindowRect(&rOrgAD6);
		m_LblAD7.GetWindowRect(&rOrgAD7);
		this->GetWindowRect(&rOrgMain);
		this->ScreenToClient(&rOrgAD0);
		this->ScreenToClient(&rOrgAD1);
		this->ScreenToClient(&rOrgAD6);
		this->ScreenToClient(&rOrgAD7);
	

}

void CExScanVoltDlg::RestoreOrgRects()
{
	rAD0 = rOrgAD0;
	rAD1 = rOrgAD1;
	rAD6 = rOrgAD6;
	rAD7 = rOrgAD7;
	rMain = rOrgMain;
}

void CExScanVoltDlg::UpdateColRects()
{
	m_LblAD0.GetWindowRect(&rAD0);		
	m_LblAD1.GetWindowRect(&rAD1);
	m_LblAD6.GetWindowRect(&rAD6);
	m_LblAD7.GetWindowRect(&rAD7);	
	this->ScreenToClient(&rAD0);
	this->ScreenToClient(&rAD1);
	this->ScreenToClient(&rAD6);
	this->ScreenToClient(&rAD7);

}
/*
void CExScanVoltDlg::ShowExScanVolts()
{
	UINT i,k;
	LONG j;	
	k=0;
	for(i=0;i<Context[i].ulNumOfExScans;i++){
		if(Context[i].ExtScan_AD0_Start >=0){
			for(j=Context[i].ExtScan_AD0_Start;j<=Context[i].ExtScan_AD0_End;j++){
				m_SAD0[j].SetWindowText(FormatVolt(Context[i].fExScans[k++],uSelected_Index));
			}
		}
		if(Context[i].ExtScan_AD1_Start >=0){
			for(j=Context[i].ExtScan_AD1_Start;j<=Context[i].ExtScan_AD1_End;j++){
				m_SAD1[j].SetWindowText(FormatVolt(Context[i].fExScans[k++],uSelected_Index));
			}
		}
		if(Context[i].ExtScan_AD6){
			m_SAD6.SetWindowText(FormatVolt(Context[i].fExScans[k++],uSelected_Index));
		}
		if(Context[i].ExtScan_AD7){
			m_SAD7.SetWindowText(FormatVolt(Context[i].fExScans[k++],uSelected_Index));
		}
	}

}
*/

void CExScanVoltDlg::SetExSubChan(BYTE bSubChan)
{

}
