/************************************************************
3217 Phoenixville Pike
Malvern, PA  19355
800 321-5355 or 610 725-8800
http://www.lawsonlabs.com
VC++ demo. program for M40x A/D board,
Uses DLL: M40x.DLL to access M401
*************************************************************/


// ExtendedScanSetupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "m40xvc.h"
#include "ExScanSetupDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExScanSetupDlg dialog
extern INDEX_CONTEXT  Context[MAX_M401];
extern UINT uSelected_Index;

CExScanSetupDlg::CExScanSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExScanSetupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExScanSetupDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CExScanSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExScanSetupDlg)
	DDX_Control(pDX, IDC_MUX_INVERTED, m_BtnMuxInv);
	DDX_Control(pDX, IDC_EX_CAL, m_BtnExCal);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CExScanSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CExScanSetupDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExScanSetupDlg message handlers

BOOL CExScanSetupDlg::OnInitDialog() 
{
	BYTE i;
	CDialog::OnInitDialog();	
	// TODO: Add extra initialization here
	//AD0 init
	m_BtnAD0[0].SubclassDlgItem(IDC_CHKAD0,this);
	m_BtnAD0[1].SubclassDlgItem(IDC_CHKAD1,this);
	m_BtnAD0[2].SubclassDlgItem(IDC_CHKAD2,this);
	m_BtnAD0[3].SubclassDlgItem(IDC_CHKAD3,this);
	m_BtnAD0[4].SubclassDlgItem(IDC_CHKAD4,this);
	m_BtnAD0[5].SubclassDlgItem(IDC_CHKAD5,this);
	m_BtnAD0[6].SubclassDlgItem(IDC_CHKAD6,this);
	m_BtnAD0[7].SubclassDlgItem(IDC_CHKAD7,this);
	m_BtnAD0[8].SubclassDlgItem(IDC_CHKAD8,this);
	m_BtnAD0[9].SubclassDlgItem(IDC_CHKAD9,this);
	m_BtnAD0[10].SubclassDlgItem(IDC_CHKAD10,this);
	m_BtnAD0[11].SubclassDlgItem(IDC_CHKAD11,this);
	m_BtnAD0[12].SubclassDlgItem(IDC_CHKAD12,this);
	m_BtnAD0[13].SubclassDlgItem(IDC_CHKAD13,this);
	m_BtnAD0[14].SubclassDlgItem(IDC_CHKAD14,this);
	m_BtnAD0[15].SubclassDlgItem(IDC_CHKAD15,this);
	//AD1 init
	m_BtnAD1[0].SubclassDlgItem(IDC_CHKAD16,this);
	m_BtnAD1[1].SubclassDlgItem(IDC_CHKAD17,this);
	m_BtnAD1[2].SubclassDlgItem(IDC_CHKAD18,this);
	m_BtnAD1[3].SubclassDlgItem(IDC_CHKAD19,this);
	m_BtnAD1[4].SubclassDlgItem(IDC_CHKAD20,this);
	m_BtnAD1[5].SubclassDlgItem(IDC_CHKAD21,this);
	m_BtnAD1[6].SubclassDlgItem(IDC_CHKAD22,this);
	m_BtnAD1[7].SubclassDlgItem(IDC_CHKAD23,this);
	m_BtnAD1[8].SubclassDlgItem(IDC_CHKAD24,this);
	m_BtnAD1[9].SubclassDlgItem(IDC_CHKAD25,this);
	m_BtnAD1[10].SubclassDlgItem(IDC_CHKAD26,this);
	m_BtnAD1[11].SubclassDlgItem(IDC_CHKAD27,this);
	m_BtnAD1[12].SubclassDlgItem(IDC_CHKAD28,this);
	m_BtnAD1[13].SubclassDlgItem(IDC_CHKAD29,this);
	m_BtnAD1[14].SubclassDlgItem(IDC_CHKAD30,this);
	m_BtnAD1[15].SubclassDlgItem(IDC_CHKAD31,this);
	//AD6
	m_BtnAD6.SubclassDlgItem(IDC_CHKAD96,this);
	//AD7
	m_BtnAD7.SubclassDlgItem(IDC_CHKAD112,this);
	/*
		Update check boxes to reflect current ext scan channel selection
	*/
	if( (Context[uSelected_Index].ExtScan_AD0_Start >=0) && (Context[uSelected_Index].ExtScan_AD0_End < 16)){
		for(i=(BYTE)Context[uSelected_Index].ExtScan_AD0_Start;i<=(BYTE)Context[uSelected_Index].ExtScan_AD0_End;i++){
			m_BtnAD0[i].SetCheck(1);
		}
	}
	if( (Context[uSelected_Index].ExtScan_AD1_Start >=0) && (Context[uSelected_Index].ExtScan_AD1_End < 16)){
		for(i=(BYTE)Context[uSelected_Index].ExtScan_AD1_Start;i<=(BYTE)Context[uSelected_Index].ExtScan_AD1_End;i++){
			m_BtnAD1[i].SetCheck(1);
		}
	}
	if(Context[uSelected_Index].ExtScan_AD6 || Context[uSelected_Index].bExtCalScan){
		Context[uSelected_Index].ExtScan_AD6 = 1;
		m_BtnAD6.SetCheck(1);
	}
	if(Context[uSelected_Index].ExtScan_AD7 || Context[uSelected_Index].bExtCalScan){
		Context[uSelected_Index].ExtScan_AD7 = 1;
		m_BtnAD7.SetCheck(1);
	}
	if(Context[uSelected_Index].bExtCalScan){
		m_BtnExCal.SetCheck(1);		
	}
	if(Context[uSelected_Index].bMuxInverted){
		m_BtnMuxInv.SetCheck(1);
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
/*
 Check all button-clicked messages for check box select/de-select messages.
 Decode all AD check box select/de-select messages to AD Chan, SubChan, select/de-select

*/
BOOL CExScanSetupDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	BYTE bADChan, bSubChan;
	BOOL flgSelect;
	if((wParam >> 16) == BN_CLICKED){
		if(MapHandleToChan((HWND)lParam, &bADChan, &bSubChan, &flgSelect)){
			SelectChan(bADChan,bSubChan, flgSelect);
		}	
		else{
			if((HWND)lParam == m_BtnExCal.GetSafeHwnd()){
				if(m_BtnExCal.GetCheck() == 0){
					Context[uSelected_Index].bExtCalScan = 0;
				}
				else{
					Context[uSelected_Index].bExtCalScan = 1;
					/*
						NOTE - in extended scan AD6 and AD7 are always included 
					*/
					Context[uSelected_Index].ExtScan_AD6 = 1;
					Context[uSelected_Index].ExtScan_AD7 = 1;
					m_BtnAD6.SetCheck(1);
					m_BtnAD7.SetCheck(1);
				}
			}
			if((HWND)lParam == m_BtnMuxInv.GetSafeHwnd()){
				if(m_BtnMuxInv.GetCheck() == 0){
					Context[uSelected_Index].bMuxInverted = 0;
				}
				else{
					Context[uSelected_Index].bMuxInverted = 1;
				}			
			}
		}
	}
	return CDialog::OnCommand(wParam, lParam);
}

BOOL CExScanSetupDlg::MapHandleToChan(HWND hWnd, PBYTE pADChan, PBYTE pSubChan, PBOOL pflgSelect)
{
	BYTE i;
	//Iterate through all the button objects looking for a match
	//AD 0 sub chan ?
	for(i=0;i<16;i++){
		if(m_BtnAD0[i].GetSafeHwnd() == hWnd){
			*pADChan = 0;
			*pSubChan = i;
			if(m_BtnAD0[i].GetCheck() == 0){
				*pflgSelect = FALSE;
			}
			else{
				*pflgSelect = TRUE;
			}
			return TRUE;
		}
	}
	//AD 1 sub chan ?
	for(i=0;i<16;i++){
		if(m_BtnAD1[i].GetSafeHwnd() == hWnd){
			*pADChan = 1;
			*pSubChan = i;
			if(m_BtnAD1[i].GetCheck() == 0){
				*pflgSelect = FALSE;
			}
			else{
				*pflgSelect = TRUE;
			}
			return TRUE;
		}
	}
	//AD 6 ?
	if(m_BtnAD6.GetSafeHwnd() == hWnd){
		*pADChan = 6;
		if(m_BtnAD6.GetCheck() == 0){
			*pflgSelect = FALSE;
		}
		else{
			*pflgSelect = TRUE;
		}		
		return TRUE;
	}
	//AD 7 ?
	if(m_BtnAD7.GetSafeHwnd() == hWnd){
		*pADChan = 7;		
		if(m_BtnAD7.GetCheck() == 0){
			*pflgSelect = FALSE;
		}
		else{
			*pflgSelect = TRUE;
		}		
		return TRUE;
	}
	return FALSE;
}
/*
	Called when user select a channel. The above functions translate
	button click messages to AD chan, SubChan, select/de-select and 
	call this function.
*/
void CExScanSetupDlg::SelectChan(BYTE bADChan, BYTE bSubChan, BOOL flgSelect)
{
	BYTE i;
	/*
	CString s;		
	if(flgSelect){
		s.Format("ADChan%d, SubChan%d, Selected",bADChan, bSubChan);
		AfxMessageBox(s);
	}
	else{
		s.Format("ADChan%d, SubChan%d, De-selected",bADChan, bSubChan);
		AfxMessageBox(s);
	}
	*/
	switch(bADChan){

		case 0:
			if(flgSelect){
				//An AD0 subc chan was selected, make continuous selection
				if(Context[uSelected_Index].ExtScan_AD0_Start < 0){
					Context[uSelected_Index].ExtScan_AD0_Start = Context[uSelected_Index].ExtScan_AD0_End = bSubChan;
				}
				else if(bSubChan < Context[uSelected_Index].ExtScan_AD0_Start){
					for(i=bSubChan;i<Context[uSelected_Index].ExtScan_AD0_Start;i++){
						m_BtnAD0[i].SetCheck(1);
					}
					Context[uSelected_Index].ExtScan_AD0_Start = bSubChan;
				}
				else{
					for(i=Context[uSelected_Index].ExtScan_AD0_End+1;i<=bSubChan;i++){
						m_BtnAD0[i].SetCheck(1);
					}
					Context[uSelected_Index].ExtScan_AD0_End = bSubChan;
				}
			}
			else{
				//drop all higher subchannels
				for(i=bSubChan;i<=Context[uSelected_Index].ExtScan_AD0_End;i++){
					m_BtnAD0[i].SetCheck(0);
				}
				
				if(Context[uSelected_Index].ExtScan_AD0_Start == bSubChan){
					//first sub chan then skip AD Chan
					Context[uSelected_Index].ExtScan_AD0_Start = -1;
				}
				else{				
					Context[uSelected_Index].ExtScan_AD0_End = bSubChan-1;
				}
				
			}
			break;


		case 1:
			if(flgSelect){
				//An AD1 subc chan was selected, make continuous selection
				if(Context[uSelected_Index].ExtScan_AD1_Start < 0){
					Context[uSelected_Index].ExtScan_AD1_Start = Context[uSelected_Index].ExtScan_AD1_End = bSubChan;
				}
				else if(bSubChan < Context[uSelected_Index].ExtScan_AD1_Start){
					for(i=bSubChan;i<Context[uSelected_Index].ExtScan_AD1_Start;i++){
						m_BtnAD1[i].SetCheck(1);
					}
					Context[uSelected_Index].ExtScan_AD1_Start = bSubChan;
				}
				else{
					for(i=Context[uSelected_Index].ExtScan_AD1_End+1;i<=bSubChan;i++){
						m_BtnAD1[i].SetCheck(1);
					}
					Context[uSelected_Index].ExtScan_AD1_End = bSubChan;
				}
			}
			else{
				for(i=bSubChan;i<=Context[uSelected_Index].ExtScan_AD1_End;i++){
					m_BtnAD1[i].SetCheck(0);
				}
				
				if(Context[uSelected_Index].ExtScan_AD1_Start == bSubChan){
					//first sub chan then skip AD Chan
					Context[uSelected_Index].ExtScan_AD1_Start = -1;
				}
				else{				
					Context[uSelected_Index].ExtScan_AD1_End = bSubChan-1;
				}

			}
			break;


		case 6:
			if(flgSelect){
				Context[uSelected_Index].ExtScan_AD6 = 1;
			}
			else{
				if(Context[uSelected_Index].bExtCalScan){
					//cannot unselect AD6 in calibrations scan
					Context[uSelected_Index].ExtScan_AD6 = 1;
					m_BtnAD6.SetCheck(1);
				}
				else
					Context[uSelected_Index].ExtScan_AD6 = 0;
			}
			break;

		case 7:
			if(flgSelect){
				Context[uSelected_Index].ExtScan_AD7 = 1;
			}
			else{
				if(Context[uSelected_Index].bExtCalScan){
					//cannot unselect AD7 in calibrations scan
					Context[uSelected_Index].ExtScan_AD7 = 1;
					m_BtnAD7.SetCheck(1);
				}
				else{
					Context[uSelected_Index].ExtScan_AD7 = 0;
				}
			}
			break;

	}


}

//DEL void CExScanSetupDlg::OnExCal() 
//DEL {
//DEL 	// TODO: Add your control notification handler code here
//DEL 	//Note - AD Chan6 and 7 are always selected in calibration scan
//DEL 	if(m_BtnExCal.GetCheck()){
//DEL 		m_BtnAD6.SetCheck(1);
//DEL 		m_BtnAD7.SetCheck(1);
//DEL 	}
//DEL 	
//DEL }

//DEL void CExScanSetupDlg::OnChkad96() 
//DEL {
//DEL 	// TODO: Add your control notification handler code here
//DEL 	
//DEL 	
//DEL }

//DEL void CExScanSetupDlg::OnChkad112() 
//DEL {
//DEL 	// TODO: Add your control notification handler code here
//DEL 	
//DEL }
