/************************************************************
3217 Phoenixville Pike
Malvern, PA  19355
800 321-5355 or 610 725-8800
http://www.lawsonlabs.com
VC++ demo. program for M40x A/D board,
Uses DLL: M40x.DLL to access M401
*************************************************************/


// Scan_Error_Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "M40xVC.h"
#include "SE_Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CM40xVCApp theApp;
/////////////////////////////////////////////////////////////////////////////
// CScan_Error_Dlg dialog

extern UINT uSelected_Index;
CScan_Error_Dlg::CScan_Error_Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScan_Error_Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScan_Error_Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CScan_Error_Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScan_Error_Dlg)
	DDX_Control(pDX, IDC_DATA_MISSING, m_Data_Missing);
	DDX_Control(pDX, IDC_CHECKSUM_ERROR, m_Checksum_Error);
	DDX_Control(pDX, IDC_BUFFER_OVERFLOW, m_Buffer_Overflow);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CScan_Error_Dlg, CDialog)
	//{{AFX_MSG_MAP(CScan_Error_Dlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScan_Error_Dlg message handlers

void CScan_Error_Dlg::ShowError()
{
	if(theApp.DLL_Scan_obj[uSelected_Index].bScanBuffOverLapped)
		m_Buffer_Overflow.SetCheck(1);
	else
		m_Buffer_Overflow.SetCheck(0);

	if( theApp.DLL_Scan_obj[uSelected_Index].bChkSumErr)
		m_Checksum_Error.SetCheck(1);
	else
		m_Checksum_Error.SetCheck(0);

	if(theApp.DLL_Scan_obj[uSelected_Index].bADChipRegCorrupted)
		m_Data_Missing.SetCheck(1);
	else
		m_Data_Missing.SetCheck(0);	

}

BOOL CScan_Error_Dlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	ShowError();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
